﻿using System.ComponentModel;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// UI 헬퍼
    /// </summary>
    public class UIHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 디자인 모드 여부
        /// </summary>
        private static bool? _isDesignMode;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 디자인 모드 여부 - IsDesignMode

        /// <summary>
        /// 디자인 모드 여부
        /// </summary>
        public static bool IsDesignMode
        {
            get
            {
                if(!_isDesignMode.HasValue)
                {
                    DependencyProperty property = DesignerProperties.IsInDesignModeProperty;

                    _isDesignMode = (bool)DependencyPropertyDescriptor.FromProperty
                    (
                        property,
                        typeof(FrameworkElement)
                    ).Metadata.DefaultValue;
                }

                return _isDesignMode.Value;
            }
        }

        #endregion
    }
}